#ifndef __CHM_EVENT_H__
#define __CHM_EVENT_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: CHMevent
//
// Description: 
//
// A portable syncronization primitive in the style of Win32 Events.
//
// Author: Steven Dodd
// Date:   Jan 28, 2009
//
//---------------------------------------------------------------------------

#include <CHM/CHMminCInclude.h>

CHM_DLL_FUNC(CHMeventCreate)
(
   CHMeventHandle* HandleOut,
   CHMboolean ManualReset
);

CHM_DLL_FUNC(CHMeventDestroy)
(
   CHMeventHandle Handle
);

// Only valid for events created with ManualReset = true.  Calling for events
// created with ManualReset = false will lead to undefined behavior.
CHM_DLL_FUNC(CHMeventReset)
(
   CHMeventHandle Handle
);

CHM_DLL_FUNC(CHMeventSignal)
(
   CHMeventHandle Handle
);

CHM_DLL_FUNC(CHMeventWait)
(
   CHMeventHandle Handle
);

CHM_DLL_FUNC(CHMeventWaitWithTimeout)
(
   CHMeventHandle Handle,
   CHMuint32 TimeoutInMilliseconds,
   CHMboolean* SignalledOut
);

#endif // end of defensive include
