#ifndef __CHM_MIN_CINCLUDE_H__
#define __CHM_MIN_CINCLUDE_H__
//------------------------------------------------------------------------
// Copyright (C) 1997-2005 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMminimumInclude.h 
//
// Description:
//
// Minimal include file used by exported DLL interface classes
//
// Author: Eliot Muir
// Date:   Wed 09/09/1998 
//
//---------------------------------------------------------------------------


#include <stdlib.h>
#include <CHM/CHMunicode.h>

typedef void* CHMengineStubHandle;
typedef void* CHMengineHandle;
typedef void* CHMbatchSegmentHandle;
typedef void* CHMtableHandle;
typedef void* CHMtableDefinitionHandle;
typedef void* CHMdateTimeHandle;
typedef void* CHMuntypedMessageTreeHandle;
typedef void* CHMconfigHandle;
typedef void* CHMsegmentHandle;
typedef void* CHMcompositeHandle;
typedef void* CHMdateTimeGrammarHandle;
typedef void* CHMenumerationGrammarHandle;
typedef void* CHMmessageHandle;
typedef void* CHMmessageNodeAddressHandle;
typedef void* CHMnodeAddressHandle;
typedef void* CHMmessageGrammarHandle;
typedef void* CHMmapItemHandle;
typedef void* CHMtableGrammarHandle;
typedef void* CHMsegmentValidationRuleHandle;
typedef double DATE;
typedef void* CHMresult;
typedef void* CHMreferenceHandle;
typedef void* CHMdllHandle;
typedef void* CHMeventHandle;

#define CHM_OK                 0
#define CHM_UNKNOWN_EXCEPTION -1

#ifdef CHM_NO_BOOLEAN_TYPE
   typedef int CHMboolean;
   #define true 1
   #define false 0
#else
#ifdef __cplusplus
   typedef bool CHMboolean;
#else
   typedef int CHMboolean;
#endif
#endif

// The following ifdef block is the standard way of creating macros which make exporting
// from a DLL simpler. All files within this DLL are compiled with the CHAMDLL_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see
// CHAMDLL_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.

#ifdef __cplusplus
#   define CHM_EXTERN_C extern "C"
#else
#   define CHM_EXTERN_C extern
#endif

#ifdef CHM_DLL_EXPORTS
#   ifdef WIN32
#      ifdef __BORLANDC__
#         define CHM_DLL_FUNC(Y) CHM_EXTERN_C CHMresult _export Y
#         define CHM_DLL_CALL(Y) Y 
#      elif defined(CHM_64)
#         define CHM_DLL_FUNC(Y) CHM_EXTERN_C __declspec(dllexport) CHMresult __stdcall Y
#         define CHM_DLL_CALL(Y) Y
#      else
#         define CHM_DLL_FUNC(Y) CHM_EXTERN_C __declspec(dllexport) CHMresult __stdcall Y
#         define CHM_DLL_CALL(Y) Y 
#      endif
#   else
#      define CHM_DLL_FUNC(Y) CHM_EXTERN_C CHMresult _##Y
#      define CHM_DLL_CALL(Y) _##Y
#   endif
#else 
#   ifdef WIN32
#      ifdef __BORLANDC__
#         define CHM_DLL_FUNC(Y) CHM_EXTERN_C CHMresult _import __stdcall _##Y
#         define CHM_DLL_CALL(Y) _##Y
#      elif defined(CHM_64)
#         define CHM_DLL_FUNC(Y) CHM_EXTERN_C __declspec(dllimport) CHMresult __stdcall Y
#         define CHM_DLL_CALL(Y) Y
#      else  
#         define CHM_DLL_FUNC(Y) CHM_EXTERN_C __declspec(dllimport) CHMresult __stdcall _##Y
#         define CHM_DLL_CALL(Y) _##Y 
#      endif
#   else
#      define CHM_DLL_FUNC(Y) CHM_EXTERN_C CHMresult _##Y
#      define CHM_DLL_CALL(Y) _##Y
#   endif
#endif

#ifndef NULL
#define NULL 0
#endif
#endif // end of defensive include
