//---------------------------------------------------------------------------
//
// Copyright (C) 1997-2004 iNTERFACEWARE Inc.  All Rights Reserved
//
//
// Module: Definition of CHMreference object
//
// Description:
//
// Parent class for all reference counted objects
//
// Author: Henry
// Date:   07/15/03
//
//
//---------------------------------------------------------------------------

#ifndef __CHM_REFERENCE__
#define __CHM_REFERENCE__

#include <stdlib.h>

class CHMreference
{
public:
   CHMreference();
   virtual ~CHMreference();

   void AddRef() const;
   void Release() const;

protected:
   size_t m_CountOfRef;
};


inline CHMreference::CHMreference()
 : m_CountOfRef(0)
{
  // do nothing
}

inline CHMreference::~CHMreference()
{
}

inline void CHMreference::AddRef() const
{
   ((CHMreference*)this)->m_CountOfRef++;
}

inline void CHMreference::Release() const
{
   ((CHMreference*)this)->m_CountOfRef--;
   if (0 == m_CountOfRef)
   {
      delete (CHMreference*)this;
   }
}

#endif // end of defensive include
